// BusyProgressDlg.cpp : implementation file
//

#include "stdafx.h"
#include "BusyProgress.h"
#include "BusyProgressDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBusyProgressDlg dialog

CBusyProgressDlg::CBusyProgressDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CBusyProgressDlg::IDD, pParent)
	, m_nSpeed(250)
{
	//{{AFX_DATA_INIT(CBusyProgressDlg)
	m_nIBPadding = m_ctlBusy.GetInterBlockPadding();
	m_nNumBlocks = m_ctlBusy.GetNumSteps();
	m_nMode = 0;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

CBusyProgressDlg::~CBusyProgressDlg()
{
}

void CBusyProgressDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CBusyProgressDlg)
	DDX_Control(pDX, IDC_BUTTON_COLBLOCKFACEHI, m_btnColBFaceHi);
	DDX_Control(pDX, IDC_BUTTON_COLBLOCKEDGEHI, m_btnColBEdgeHi);
	DDX_Control(pDX, IDC_BUTTON_COLBLOCKFACE, m_btnColBFace);
	DDX_Control(pDX, IDC_BUTTON_COLBLOCKEDGE, m_btnColBEdge);
	DDX_Control(pDX, IDC_BUTTON_COLBKG, m_btnColBkg);
	DDX_Control(pDX, IDC_STATIC_BUSYPROGRESS, m_ctlBusy);
	DDX_Text(pDX, IDC_EDIT_SPEED, m_nSpeed);
	DDX_Text(pDX, IDC_EDIT_IBPADDING, m_nIBPadding);
	DDV_MinMaxInt(pDX, m_nIBPadding, 0, 20);
	DDX_Text(pDX, IDC_EDIT_NUMBLOCKS, m_nNumBlocks);
	DDX_Radio(pDX, IDC_RADIO_MODE, m_nMode);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CBusyProgressDlg, CDialog)
	//{{AFX_MSG_MAP(CBusyProgressDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON_START, OnButtonStart)
	ON_WM_DESTROY()
	ON_EN_CHANGE(IDC_EDIT_SPEED, OnChangeEditSpeed)
	ON_EN_CHANGE(IDC_EDIT_IBPADDING, OnChangeEditIbpadding)
	ON_EN_CHANGE(IDC_EDIT_NUMBLOCKS, OnChangeEditNumblocks)
	ON_BN_CLICKED(IDC_BUTTON_COLBKG, OnButtonColbkg)
	ON_BN_CLICKED(IDC_BUTTON_COLBLOCKFACE, OnButtonColblockface)
	ON_BN_CLICKED(IDC_BUTTON_COLBLOCKEDGE, OnButtonColblockedge)
	ON_BN_CLICKED(IDC_BUTTON_COLBLOCKEDGEHI, OnButtonColblockedgehi)
	ON_BN_CLICKED(IDC_BUTTON_COLBLOCKFACEHI, OnButtonColblockfacehi)
	ON_BN_CLICKED(IDC_RADIO_MODE, OnRadioModeBusy)
	ON_BN_CLICKED(IDC_RADIO2, OnRadioModeProgress)
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBusyProgressDlg message handlers

BOOL CBusyProgressDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	//
	// Initilialise the BusyProgressCtrl
	m_ctlBusy.SetNumSteps(20);
	m_ctlBusy.SetSpeed(m_nSpeed);

	// initialise the colour buttons
	m_btnColBEdge.SetColBkg( m_ctlBusy.GetColBlockEdge() );
	m_btnColBFace.SetColBkg( m_ctlBusy.GetColBlockFace() );
	m_btnColBEdgeHi.SetColBkg( m_ctlBusy.GetColBlockEdgeHi() );
	m_btnColBFaceHi.SetColBkg( m_ctlBusy.GetColBlockFaceHi() );
	m_btnColBkg.SetColBkg( m_ctlBusy.GetColBkg() );
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

/////////////////////////////////////////////////////////////////////////////

void CBusyProgressDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CBusyProgressDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CBusyProgressDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

/////////////////////////////////////////////////////////////////////////////

void CBusyProgressDlg::OnButtonStart() 
{
	if ( m_ctlBusy.GetMode() & BPC_MODE_BUSY )
	{
		if ( !m_ctlBusy.IsRunning() )
		{
			if ( m_ctlBusy.GetMode() & BPC_MODE_BUSY)
				m_ctlBusy.Start();
			GetDlgItem(IDC_BUTTON_START)->SetWindowText("Stop");
		}
		else
		{
			m_ctlBusy.End();
			GetDlgItem(IDC_BUTTON_START)->SetWindowText("Start");
		}
	}
	else if ( m_ctlBusy.GetMode() & BPC_MODE_PROGRESS )
	{
		CString			strText;

		GetDlgItem(IDC_BUTTON_START)->GetWindowText(strText);
		if ( !strText.CompareNoCase( "Start" ) )
		{
			m_ctlBusy.Reset();
			SetTimer(0, 100, NULL);
			GetDlgItem(IDC_BUTTON_START)->SetWindowText("Stop");
		}
		else
		{
			KillTimer(0);
			GetDlgItem(IDC_BUTTON_START)->SetWindowText("Start");
		}
	}
}

/////////////////////////////////////////////////////////////////////////////

void CBusyProgressDlg::OnDestroy() 
{
	m_ctlBusy.End();

	CDialog::OnDestroy();
}

/////////////////////////////////////////////////////////////////////////////

void CBusyProgressDlg::OnChangeEditSpeed() 
{
	UpdateData();
	m_ctlBusy.SetSpeed(m_nSpeed);
}

/////////////////////////////////////////////////////////////////////////////

void CBusyProgressDlg::OnChangeEditIbpadding() 
{
	UpdateData();
	
	m_ctlBusy.SetInterBlockPadding(m_nIBPadding);
	m_ctlBusy.Invalidate();
}

/////////////////////////////////////////////////////////////////////////////

void CBusyProgressDlg::OnChangeEditNumblocks() 
{
	UpdateData();
	
	m_ctlBusy.Reset();
	m_ctlBusy.SetNumSteps(m_nNumBlocks);
	m_ctlBusy.Invalidate();
}

/////////////////////////////////////////////////////////////////////////////

void CBusyProgressDlg::OnButtonColbkg() 
{
	CColorDialog			dlg( m_ctlBusy.GetColBkg(), CC_FULLOPEN );
	
	if ( dlg.DoModal() == IDOK )
	{
		m_ctlBusy.SetColBkg( dlg.GetColor() );
		m_btnColBkg.SetColBkg( dlg.GetColor() );
		m_btnColBkg.Invalidate();
		m_ctlBusy.Invalidate();
	}
}

/////////////////////////////////////////////////////////////////////////////

void CBusyProgressDlg::OnButtonColblockface() 
{
	CColorDialog			dlg( m_ctlBusy.GetColBlockFace(), CC_FULLOPEN );
	
	if ( dlg.DoModal() == IDOK )
	{
		m_ctlBusy.SetColBlockFace( dlg.GetColor() );
		m_btnColBFace.SetColBkg( dlg.GetColor() );
		m_btnColBFace.Invalidate();
		m_ctlBusy.Invalidate();
	}
}

/////////////////////////////////////////////////////////////////////////////

void CBusyProgressDlg::OnButtonColblockedge() 
{
	CColorDialog			dlg( m_ctlBusy.GetColBlockEdge(), CC_FULLOPEN );
	
	if ( dlg.DoModal() == IDOK )
	{
		m_ctlBusy.SetColBlockEdge( dlg.GetColor() );
		m_btnColBEdge.SetColBkg( dlg.GetColor() );
		m_btnColBEdge.Invalidate();
		m_ctlBusy.Invalidate();
	}
}

/////////////////////////////////////////////////////////////////////////////

void CBusyProgressDlg::OnButtonColblockedgehi() 
{
	CColorDialog			dlg( m_ctlBusy.GetColBlockEdgeHi(), CC_FULLOPEN );
	
	if ( dlg.DoModal() == IDOK )
	{
		m_ctlBusy.SetColBlockEdgeHi( dlg.GetColor() );
		m_btnColBEdgeHi.SetColBkg( dlg.GetColor() );
		m_btnColBEdgeHi.Invalidate();
		m_ctlBusy.Invalidate();
	}
}

/////////////////////////////////////////////////////////////////////////////

void CBusyProgressDlg::OnButtonColblockfacehi() 
{
	CColorDialog			dlg( m_ctlBusy.GetColBlockFaceHi(), CC_FULLOPEN );
	
	if ( dlg.DoModal() == IDOK )
	{
		m_ctlBusy.SetColBlockFaceHi( dlg.GetColor() );
		m_btnColBFaceHi.SetColBkg( dlg.GetColor() );
		m_btnColBFaceHi.Invalidate();
		m_ctlBusy.Invalidate();
	}
}

/////////////////////////////////////////////////////////////////////////////

void CBusyProgressDlg::OnRadioModeBusy() 
{
	UpdateData();	

	m_ctlBusy.SetMode(BPC_MODE_BUSY);
}

/////////////////////////////////////////////////////////////////////////////

void CBusyProgressDlg::OnRadioModeProgress() 
{
	UpdateData();	

	m_ctlBusy.SetMode(BPC_MODE_PROGRESS);
}

/////////////////////////////////////////////////////////////////////////////

void CBusyProgressDlg::OnTimer(UINT nIDEvent) 
{
	int				nLower, nUpper;
	int				nCurPos = m_ctlBusy.GetCurPos();

	m_ctlBusy.GetRange(nLower, nUpper);
	if ( nCurPos >= nUpper )
		m_ctlBusy.SetCurPos(nLower);
	else
		m_ctlBusy.StepIt();
	
	CDialog::OnTimer(nIDEvent);
}
